unit ModuleRar;

interface

uses ModuleNeurox, SysUtils, Windows, Registry, Classes;

type
  TRarModule = class(TNeurox)
     private
      FRarFileName: string;
      FRarInstalled: boolean;
     public
      constructor Create; reintroduce;
      procedure CreateRarFile(RarDest: string; Files: TStringList);
      procedure UpdateRarFile(Dest: string; Files: TStringList);
      procedure CheckWinRarInstalled;
     published
      property RarInstalled: boolean read FRarInstalled write FRarInstalled;
      property RarFileName: string read FRarFileName write FRarFileName;
  end;

implementation

procedure TRarModule.UpdateRarFile(Dest: string; Files: TStringList);
var
  cmd: string;
  i: integer;
begin
if FRarInstalled = false then exit;
  cmd:= FRarFileName + ' u ' + Dest + ' ';
  for i := 0 to Files.Count - 1 do
      begin
        if FileExists(Files.Strings[i]) then
          begin
            Cmd:= Cmd + Files.Strings[i];
            if i < Files.Count -1 then Cmd:= Cmd + ' ';
          end;
      end;
  WinExec(pchar(Cmd), SW_HIDE);
  Sleep(7000);
end;

procedure TRarModule.CreateRarFile(RarDest: string; Files: TStringList);
var
  cmd: string;
  i: integer;
begin
if FRarInstalled = false then exit;
  cmd:= FRarFileName + ' a ' + RarDest + ' ';
  for i := 0 to Files.Count - 1 do
      begin
        if FileExists(Files.Strings[i]) then
          begin
            Cmd:= Cmd + Files.Strings[i];
            if i < Files.Count -1 then Cmd:= Cmd + ' ';
          end;
      end;
  WinExec(pchar(Cmd), SW_HIDE);
  Sleep(7000);
end;

procedure TRarModule.CheckWinRarInstalled;
var
Reg: TRegistry;
begin
 FRarFileName:= EmptyStr;
    Reg:= TRegistry.Create;
    Reg.RootKey:= HKEY_LOCAL_MACHINE;
    Reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\WinRAR archiver', false);
    FRarFileName:=Reg.ReadString('UninstallString');
    FRarFileName:=ExtractFilePath(FRarFileName);
    FRarFileName:=FRarFileName + 'rar.exe';

      if FileExists(FRarFileName)=false then begin
        FRarInstalled:=false;
        FRarFileName:= EmptyStr;
      end else
        FRarInstalled:=true;
end;

constructor TRarModule.Create;
begin
inherited Create(True);
  FreeOnTerminate:= True;
  CheckWinRarInstalled;
end;

end.
