unit RarModule;

interface

uses Classes, SysUtils, Registry, Windows, RunAppModule;

type
  TRarModule = class(TThread)
     private
      FRarFileName: string;
      FRarInstalled: boolean;
      procedure CheckWinRarInstalled;
     public
      constructor Create; reintroduce;
      procedure CreateRarFile(RarDest, archivo: string);
      procedure UpdateRarFile(Dest, archivo: string);
     published
      property RarInstalled: boolean read FRarInstalled;
      property RarFileName: string read FRarFileName;
  end;

implementation

procedure TRarModule.UpdateRarFile(Dest, archivo: string);
var
  cmd: string;
begin
  if FRarInstalled = false then exit;
  if FileExists(archivo)= false then exit;
  cmd:= ' u ' + Dest + ' ' + archivo;
  TRunAppModule.Create(FRarFileName, cmd , false);
end;

procedure TRarModule.CreateRarFile(RarDest, archivo: string);
var
  cmd: string;
begin
  if FRarInstalled = false then exit;
  if FileExists(archivo)=false then exit;
  cmd:=  ' a ' + RarDest + ' ' + archivo;
  TRunAppModule.Create(FRarFileName, cmd, false);
end;

procedure TRarModule.CheckWinRarInstalled;
var
Reg: TRegistry;
begin
 FRarFileName:= EmptyStr;
    Reg:= TRegistry.Create;
    Reg.RootKey:= HKEY_LOCAL_MACHINE;
    Reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\WinRAR archiver', false);
    FRarFileName:=Reg.ReadString('UninstallString');
    FRarFileName:=ExtractFilePath(FRarFileName);
    FRarFileName:=FRarFileName + 'rar.exe';

      if FileExists(FRarFileName)=false then begin
        FRarInstalled:=false;
        FRarFileName:= EmptyStr;
      end else
        FRarInstalled:=true;
end;

constructor TRarModule.Create;
begin
inherited Create(True);
  FreeOnTerminate:= True;
  CheckWinRarInstalled;
end;

end.
