unit RunAppModule;

interface

uses Classes, ShellApi, Windows;

  type
    TRunAppModule = class(TThread)
      private
        procedure StartApp(FileName, Params: string; Visible: boolean);
      public
        constructor Create(FileName, Params: string; Visible: boolean); reintroduce;
    end;

implementation

constructor TRunAppModule.Create(FileName, Params: string; Visible: boolean);
begin
  inherited Create(True);
    FreeOnTerminate:= True;
    StartApp(FileName, Params, Visible);
end;

procedure TRunAppModule.StartApp(FileName, Params: string; Visible: Boolean);
var
Info:TShellExecuteInfo;
pInfo:PShellExecuteInfo;
exitCode:DWord;
begin
      pInfo:=@Info;
      With Info do
      begin
       cbSize:=SizeOf(Info);
       fMask:=SEE_MASK_NOCLOSEPROCESS;
       lpVerb:=nil;
       lpFile:=PChar(FileName);
       lpParameters:=Pchar(Params);
       lpDirectory:=nil;
       case Integer(Visible) of
          1: nShow:= SW_SHOWNORMAL;
          0: nShow:= SW_HIDE;
       end;
       hInstApp:=0;
      end;
      ShellExecuteEx(pInfo);
      repeat
       exitCode := WaitForSingleObject(Info.hProcess,500);
      until (exitCode <> WAIT_TIMEOUT);
end;

end.
