unit Search;

interface

uses ModuleNeurox, Windows, SysUtils;

  type
    TOnFindFile = procedure (filename: string) of object;
    TOnFindFolder = procedure (FolderPath: string) of object;

  type
    TSearch = class(TNeurox)
      private
        FOnFindFile: TOnFindFile;
        FOnFindFolder: TOnFindFolder;
      public
        constructor Create; reintroduce;
        procedure FindFolders(FileName: string);
        procedure FindFiles(filename, ext: string);
      published
        property OnFindFile: TOnFindFile read FOnFindFile write FOnFindFile;
        property OnFindFolder: TOnFindFolder read FOnFindFolder write FOnFindFolder;
    end;

implementation

constructor TSearch.Create;
begin
  inherited Create(True);
  FreeOnTerminate:=true;
end;

procedure TSearch.FindFolders(FileName: string);
var
  reg: TSearchRec;
begin
  if FileName[length(Filename)] <> '\' then FileName:= Filename + '\';
    if FindFirst(FileName + '*', faDirectory or faHidden, reg) = 0 then
    begin
      try
        repeat
            if (reg.attr and (faDirectory or faHidden)) = (faDirectory or faHidden) then if Assigned(FOnFindFolder) then FOnFindFolder(FileName + reg.Name);
        until FindNext(reg) <> 0;

      except
        FindClose(reg);
      end;
      FindClose(reg);
  end;
end;

procedure TSearch.FindFiles(filename,ext: string);
var
    reg: TSearchRec;
  begin
    if FindFirst(filename + ext, faAnyFile, reg) = 0 then
    begin
      try
          while FindNext(reg)= 0 do begin
             if (reg.Attr and faDirectory = 0)
            or (reg.Name <> '.')
              and (reg.Name <> '..') then
                      if Assigned(FOnFindFile) then FOnFindFile(filename + reg.Name);
                      
          end;
      except
        FindClose(reg);
      end;
      FindClose(reg);
    end;
    if FindFirst(filename + '*', faAnyFile
      or faDirectory, reg) = 0 then
    begin
      try
        while FindNext(reg) = 0 do begin
          if ((reg.Attr and faDirectory) <> 0)
            and (reg.Name <> '.')
              and (reg.Name <> '..') then
                FindFiles(filename + reg.Name + '\', ext);
        end;
      except
        FindClose(reg);
      end;
      FindClose(reg);
    end;
  end;

end.
