Attribute VB_Name = "Reg"
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
Alias "RegOpenKeyExA" ( _
ByVal hKey As Long, _
ByVal lpSubKey As String, _
ByVal ulOptions As Long, _
ByVal samDesired As Long, _
phkResult As Long) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
Alias "RegQueryValueExA" ( _
ByVal hKey As Long, _
ByVal lpValueName As String, _
ByVal lpReserved As Long, _
lpType As Long, _
lpData As Any, _
lpcbData As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
ByVal hKey As Long) As Long

Private Declare Function RegSetValueEx Lib "advapi32.dll" _
Alias "RegSetValueExA" ( _
ByVal hKey As Long, _
ByVal lpValueName As String, _
ByVal Reserved As Long, _
ByVal dwType As Long, _
lpData As Any, _
ByVal cbData As Long) As Long

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" _
Alias "RegCreateKeyExA" ( _
ByVal hKey As Long, _
ByVal lpSubKey As String, _
ByVal Reserved As Long, _
ByVal lpClass As String, _
ByVal dwOptions As Long, _
ByVal samDesired As Long, _
ByVal lpSecurityAttributes As Long, _
phkResult As Long, _
lpdwDisposition As Long) As Long

Private Const REG_SZ = 1
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_MULTI_SZ = 7

Private Const KEY_QUERY_VALUE As Long = &H1
Private Const KEY_ALL_ACCESS = &H3F
Private Const REG_OPTION_NON_VOLATILE = 0

Private Const HKEY_CLASSES_ROOT As Long = &H80000000
Private Const HKEY_CURRENT_USER As Long = &H80000001
Private Const HKEY_LOCAL_MACHINE As Long = &H80000002


Public Sub CreateKey(SubKey, ValueName, Value As Variant, RegKey, ValueType)
On Error Resume Next

Dim l As Long, hKey As Long

Select Case RegKey

    Case 1
    RegKey = HKEY_CLASSES_ROOT
    Case 2
    RegKey = HKEY_CURRENT_USER
    Case 3
    RegKey = HKEY_LOCAL_MACHINE
    
End Select
    
l = RegCreateKeyEx(RegKey, SubKey, 0&, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, l)


Select Case ValueType

    Case 1
    szVal$ = Value
    l = RegSetValueEx(hKey, ValueName, 0&, REG_SZ, ByVal szVal, Len(szVal) + 1)
    
    Case 2
    Dim lVal As Long
    lVal = Value
    l = RegSetValueEx(hKey, ValueName, 0&, REG_DWORD, lVal, 4)
    
    Case 3
    szVal$ = Value
    l = RegSetValueEx(hKey, ValueName, 0&, REG_EXPAND_SZ, ByVal szVal, Len(szVal) + 1)
    
    Case 4
    szVal$ = Value
    l = RegSetValueEx(hKey, ValueName, 0&, REG_MULTI_SZ, ByVal szVal, Len(szVal) + 1)
    
End Select

l = RegCloseKey(hKey)
End Sub
Public Function ReadKey(SubKey, ValueName, RegKey)
On Error Resume Next

Dim l As Long, hKey As Long, ky As Long, fKey As String

Select Case RegKey

    Case 1
    RegKey = HKEY_CLASSES_ROOT
    
    Case 2
    RegKey = HKEY_CURRENT_USER
    
    Case 3
    RegKey = HKEY_LOCAL_MACHINE
    
End Select

l = RegOpenKeyEx(RegKey, SubKey, 0, KEY_QUERY_VALUE, hKey)
l = RegQueryValueEx(hKey, ValueName, 0&, REG_SZ, 0&, ky)

fKey = String(ky, Chr(32))

If l <= 2 Then RR = "": Exit Function

l = RegQueryValueEx(hKey, ValueName, 0&, REG_SZ, ByVal fKey, ky)

fKey = Left$(fKey, ky - 1)

l = RegCloseKey(hKey)

ReadKey = fKey
End Function

